;*****************************************************************
; MACLIB.ASM							 *
; This file contains macro procedure definitions for EGAC16      *
; Last Revised: 2/11/88	 For toolkit version 3.00 and higher.	 *
; The ENTERP and EXITP macros do not save the AX or DX registers *
; These are used in some cases to return pointers or error codes *
;***************************************************************** 
; ////////////////////////////////////////////////////////////////
; This macro defines the code segment and the ASSUME statement
START_CODE_SEG	MACRO  lang,module
TRUE	EQU	1
FALSE	EQU	0
NearPro EQU	0
FarPro	EQU	1
	if ( (lang eq MICROSOFT) or (lang eq TURBO_PASCAL) )
	;;------------------ Code Segment Definition -----------;
	cseg	segment para public 'code'			;
		assume cs:cseg,ds:cseg				;
		;						;
		; This macro is used to save the registers and	;
		; set the base pointer for entering a procedure	;
		; Note: DS: is automatically saved		;
		ENTERP	macro name,dist,regs			;
			IF ( dist EQ FarPro )			;
		name	proc	far				;
			public	name				;
			push	bp				;
			mov	bp,sp				;
			push	ds				;
			; save registers			;
			push	bx				;
			push	cx				;
			push	si				;
			push	di				;
			push	bp				;
			push	es				;
			; set the data segment			;
			mov	ax,cs				;
			mov	ds,ax				;
			if( lang eq TURBO_PASCAL )		;
			;; This is used to cleanup after EGA	;
			;; BIOS's when used by TURBO		;
			;; ---------------------------------	;
				; Reset Mask for clone BIOS	;
				mov	dx,SEQ_IR		;
				mov	ah,TK_WRITE_MASK	;
				mov	al,MAP_MASK_PTR		;
				out	dx,ax			;
			endif					;
			ELSE					;
		name	proc	near				;
			    irp      x,<regs>			;
			    push     x				;
			    endm				;
			ENDIF					;
		ENDM						;
		; This is used to exit a procedure.		;
		; NVARS is the number of variables passed to the;
		; routine to remove from the stack.		;
		; Note: DS: is automatically restored		;
		EXITP	macro name,dist,regs,nvars		;
			IF ( dist EQ FarPro )			;
			pop	es				;
			pop	bp				;
			pop	di				;
			pop	si				;
			pop	cx				;
			pop	bx				;
			;					;
			pop	ds				;
			mov	sp,bp				;
			pop	bp				;
			cld					;
			ret	nvars*4				;
			ELSE					;
			irp   x,<regs>				;
			pop	x				;
			endm					;
			ret					;
			ENDIF					;
		name	endp					;
		ENDM						;
		; This is used to get a passed in argument	;
		; SS:BP points to argument block		;
		; ES is modified.				;
		GET_ARG macro  destreg,argnum,numargs		;
			voff$ = ((numargs-argnum+1)*4)+2	;
			push	bx				;
			les	bx,[bp+voff$]			;
			mov	destreg,es:[bx]			;
			pop	bx				;
		ENDM						;
		; This is used to set ES:BX to point at the	;
		; parameter table.				;
		SET_ESOFBX	macro  argnum,numargs		;
			voff$ = ((numargs-argnum+1)*4)+2	;
			les	bx,[bp+voff$]			;
		ENDM						;
		;; This is used to terminate the code segment	;
		END_CODE_SEG	MACRO				;
			cseg	ends				;
		ENDM						;
	endif							;
	;;******************************************************;
	if( lang eq GPX_DRIVER )				;
	;; This is set for a run time loadable driver called	;
	;; from MS C. This assumes the large memory model	;
	;;------------------					;
	cseg	segment para public 'code'			;
		assume cs:cseg,ds:cseg				;
		;						;
		; This macro is used to save the registers and	;
		; set the base pointer for entering a procedure	;
		; Note: DS: is automatically saved		;
		ENTERP	macro name,dist,regs			;
			IF ( dist EQ FarPro )			;
		_&&name	proc	far				;
			public	_&&name				;
			push	bp				;
			mov	bp,sp				;
			push	ds				;
			; save registers			;
			push	si				;
			push	di				;
			push	bp				;
			; set the data segment			;
			mov	ax,cs				;
			mov	ds,ax				;
			ELSE					;
			name	proc	near			;
			    irp      x,<regs>			;
			    push     x				;
			    endm				;
			ENDIF					;
		ENDM						;
		; This is used to exit a procedure.		;
		; NVARS is the number of variables passed to the;
		; routine to remove from the stack.		;
		; Note: DS: is automatically restored		;
		EXITP	macro name,dist,regs,nvars		;
			IF ( dist EQ FarPro )			;
			pop	bp				;
			pop	di				;
			pop	si				;
			;					;
			pop	ds				;
			mov	sp,bp				;
			pop	bp				;
			cld					;
			ret					;
			_&&name	endp				;
			ELSE					;
			irp   x,<regs>				;
			pop	x				;
			endm					;
			ret					;
			name	endp				;
			ENDIF					;
		ENDM						;
		; This is used to get a passed in argument	;
		; SS:BP points to argument block		;
		; ES is modified.				;
		GET_ARG macro  destreg,argnum,numargs		;
			voff$ = (argnum*4)+2			;
			push	bx				;
			les	bx,[bp+voff$]			;
			mov	destreg,es:[bx]			;
			pop	bx				;
		ENDM						;
		; This is used to set ES:BX to point at the	;
		; parameter table.				;
		SET_ESOFBX	macro  argnum,numargs		;
			voff$ = (argnum*4)+2			;
			les	bx,[bp+voff$]			;
		ENDM						;
		;; This is used to terminate the code segment	;
		END_CODE_SEG	MACRO				;
			cseg	ends				;
		ENDM						;
	endif							;
	;;*******************************************************
	;;							;
	if( lang eq RYAN_MCFARLAND )				;
	;;-----------------------				;
	;; Since the data segment is the same as the code	;
	;; segment, there is no trace back definition.		;
	PA@cseg	segment para public 'code'			;
		assume cs:PA@cseg,ds:PA@cseg			;
		dw	SEG PA@cseg	;; DS is within CS	;
		db	'&module'	;; 8 bytes total	;
	sp_save dw	0					;
		dd	&module					;
		dd	0					;
	argblkptr       LABEL   DWORD				;
	argblkoff	dw	?				;
	argblkseg	dw	?				;
		;						;
		; This macro is used to save the registers	;
		ENTERP	macro name,dist,regs			;
			IF ( dist EQ FarPro )			;
		name	proc	far				;
			public	name				;
			;------ save registers			;
			push	bx				;
			push	cx				;
			push	si				;
			push	di				;
			push	bp				;
			push	es				;
			;------ set the data segment		;
			mov	ax,cs				;
			mov	ds,ax				;
			mov	sp_save,sp			;
			mov	argblkoff,bx			;
			mov	argblkseg,es			;
			ELSE					;
		name	proc	near				;
			irp   x,<regs>				;
			push	x				;
			endm					;
			ENDIF					;
		ENDM						;
		; This is used to exit a procedure.		;
		; Uses some dummy variables for compatibility	;
		EXITP	macro name,dist,regs,nvars		;
			IF( dist EQ FarPro )			;
			  cld					;
			  pop	es				;
			  pop	bp				;
			  pop	di				;
			  pop	si				;
			  pop	cx				;
			  pop	bx				;
			ELSE					;
			  irp   x,<regs>			;
			  pop	x				;
			  endm					;
			ENDIF		  			;
			ret					;
		name	endp					;
		ENDM						;
		; This is used to get a passed in argument	;
		; ARGBLKPTR  points to argument block		;
		; ES: will be modified				;
		GET_ARG macro  destreg,argnum,numargs		;
			voff$ = (argnum-1)*4			;
			push	bx				;
			les	bx,argblkptr			;
			les	bx,es:[bx+voff$]		;
			mov	destreg,es:[bx]			;
			pop	bx				;
		ENDM						;
		; This is used to set ES:BX to point at the	;
		; parameter table.				;
		SET_ESOFBX	macro  argnum,numargs		;
			voff$ = (argnum-1)*4			;
			les	bx,argblkptr			;
			les	bx,es:[bx+voff$]		;
		ENDM						;
		;; This is used to terminate the code segment	;
		END_CODE_SEG	MACRO				;
			PA@cseg	ends				;
		ENDM						;
	endif							;
ENDM								;
; ////////////////////////////////////////////////////////////////
; This macro is used to save the registers for
; an interrupt service routine.
ENTERI	macro name,regs
name	proc	far
	irp   x,<regs>
	push	x
	endm
	;--------- set the data segment
	push	ax
	push	ds
	mov	ax,cs
	mov	ds,ax
ENDM
; ////////////////////////////////////////////////////////////////
; This is used to exit an interrupt service routine.
EXITI	macro name,regs
	pop	ds
	pop	ax
	irp   x,<regs>
	pop	x
	endm
	iret
name	endp
ENDM

